{	File :		FaxSTFIntf.p								}
{	Authors :	Steve Kirk 									}
{	Created :	Thursday, April 18, 1996					}
{	CopyRight:	1987 - 1996 STF Technologies, Inc.			}
{				All Rights Reserved							}

unit FaxDevIntf;

interface

uses
	MemTypes, OSIntf, ToolIntf, Folders, gestaltequ, Aliases, SysEqu, PackIntf;


const
{ ---Error Codes --- }
	kSTFToolBoxNotFound		=	-9000			{ -- STF Toolbox not found -- }
	kSTFToolBoxBusy			=	-9001			{ -- STF Toolbox could not be opened read/write -- }
	kSTFSettingsNotFound	=	-9002			{ -- STF Settings file not found -- }
	kSTFSettingsFileBusy	=	-9003			{ -- STF Settings file could not be opened read/write -- }
	kSTFNoGXSupport			=	-9004			{ -- FaxPrint GX 3.3 or greater not installed -- }
	kSTFBadIndex			=	-9005			{ -- Index out of range -- }
	kSTFBrdDrvrFail			=	-9006			{ -- Call to the STF Board Driver failed -- }
	kSTFMonitorNotFound 	=	-9007			{ -- STF FaxMonitor not found -- }
	kGetPrinterFail			=	-9008			{ -- Failed to get the printer name -- }
	KFaxPrintGXNotFound		=	-9009			{ -- FaxPrint GX not found -- }
	kFailtoSwitchDTP		=	-9010			{ -- Failed to switch the desktop printer (GX only) -- }
	
{ ---Misc Const---}
	kIdle 					= 0
	kSending				= 1
	kReceiving				= 2

{--------------------------------------------------------}
{ -- The following library calls will allow you to create faxes from the printing loop of your app		-- }
{ -- refer to the documentation sent with this Developer kit for further details on all of these calls.	-- }

{ -- addressing calls -- }

function Startup (Note: str255; SendTime: longint; AutoDeleteFax: Boolean; CallGroupFax: Boolean; CvPgId: integer; ArchiveFolderName: Str63): OSErr;
function AddDestinations (SendToFaxPhone: Str31; SendToVoicePhone: Str31; SendToCoName: Str31; SendToFirstName: Str31; SendToLastName: Str31; SendToSalutation: Str15): OSErr;
function ShutDown: OSErr;

{ -- switch printer calls -- }

function DoSwitchPrinter (NewPrinter: Str31; var OldPrinter: Str31): OSErr;
function doSwitchToFaxPrint (var oldPrinter: Str31 ): OSErr;
function doRestorePrinter: OSErr;

{ -- other stuff -- }
function doGetSoftwareState(var flag: Boolean): OSErr;
function doScanSpoolFolder: OSErr;
function isFaxSTFInstalled(var stfInstalled: integer): OSErr;
function getSTFDriverStatus (var status: integer): OSErr;		{ -- status = idle(0), sending(1), receiving(2) -- }

{ -- switch settings files calls -- }

function saveCurSettingsFile: OSErr;
function switchSettingsFiles(newSettingsFileName: Str255): OSErr
function restoreSettingsFile: OSErr;

{ -- settings calls -- }
{--------------------------------------------------------}

{ -- CallBlocking settings panel routines -- }
function saveCallBlockingState: OSErr;
function setCallBlockingState(state: Boolean, number: Str63): OSErr;		{ -- if (number == "\p") then this routine only sets the state -- }
function restoreCallBlockingState: OSErr;

{ -- Connection settings panel routines -- }
function saveConnectionSettings: OSErr;
function setConnectionSettings(portName: Str63): OSErr;
function restoreConnectionSettings: OSErr;

{ -- CoverPage settings panel routines -- }
function saveCoverPage: OSErr;						{ -- same as saveHeader -- }
function setCoverPage(name: Str63; company: Str63; faxPhone: Str63; voicePhone:Str63): OSErr;		{ -- same as setHeader -- }
function restoreCoverPage: OSErr;					{ -- same as restoreHeader -- }

{ -- Dialing settings panel routines -- }
function saveDialingSettings: OSErr;
function setDialingSettings(phone: integer; detect: integer; carrier: integer; commaPause: integer; prefix: Str63; suffix: Str63; macro: Str63);
function restoreDialingSettings: OSErr;

{ -- FaxForward settings panel routines -- }
function saveFaxForwardState: OSErr;
function setFaxForwardState(state: Boolean; number: Str63): OSErr;	{ -- pass empty string for number to only toggle the state -- }
function restoreFaxForwardState: OSErr;

{ -- FaxIn settings panel routines -- }
function saveFaxInState: OSErr;
function setFaxInState(processType: integer; day: integer; hour: integer, minute: integer): OSErr;
function restoreFaxInState: OSErr;

{ -- FaxMenu settings panel routines -- }
function saveFaxMenuSettings: OSErr;
function setFaxMenu(shiftKey: Boolean; commandKey: Boolean; optionKey: Boolean): OSErr;
function restoreFaxMenuSettings: OSErr;

{ -- FaxModem settings panel routines -- }
{ -- Never(1),Connect(2),Handshake(3),Always(4)						-- }
{ -- volume		 Low(1),Medium(2),High(3)							-- }
{ -- answerOn	Number of rings to answer on plus one.				-- }
{ -- sendSpeed	2400(1),4800(2),7200(3),9600(4),12000(5),14400(6)	-- }
{ -- recvSpeed	2400(1),4800(2),7200(3),9600(4),12000(5),14400(6)	-- }
function saveFaxModemSettings: OSErr;
function setFaxModemSettings(speakerOn: integer; volume: integer; answerOn: integer; sendSpeed: integer; recvSpeed: integer);
function restoreFaxModemSettings: OSErr;

{ -- FaxQueue settings panel routines -- }
function saveFaxQueueSettings: OSErr;
function setFaxQueueSettings(sampleRate: integer; sampleSize: integer; callGrouping: integer): OSErr;
function restoreFaxQueueSettings: OSErr;

{ -- FaxSoftware settings panel routines -- }
function saveFaxSoftwareSettings: OSErr;
function setFaxSoftwareSettings(callRetries: integer; retryInterval: integer; PageHeader: Boolean; confirmTrans: Boolean; notifyRecept: Boolean; faxStatus: Boolean; stationMessage: Str27);
function pageHeaderOn: OSErr;
function pageHeaderOff: OSErr;
function faxOn: OSErr;
function faxOff: OSErr;
function restoreFaxSoftwareSettings: OSErr;

{ -- ModemInit settings panel routines -- }
function saveModemInitSettings: OSErr;
function setModemInitSettings(initString: Str255): OSErr;
function restoreModemInitSettings: OSErr;

{ -- PageHeader settings panel routines -- }
function savePageHeader: OSErr;
function setPageHeaderOpts(icons: Boolean; date: Boolean; pages: Boolean; time: Boolean): OSErr;
function setPageHeaderStandard(voice: Boolean; orginization: Boolean): OSErr;
function setPageHeaderCustom(custHeader: Str63): OSErr;
function restorePageHeader: OSErr;

{ -- Places settings panel routines -- }

function savePlacesState: OSErr;
function setPlacesState(index: integer): OSErr;		{ -- pass -1 in index to turn off, 0 - 29 to select an entry in the location list (1 - 30) -- }
function restorePlacesState: OSErr;

{ -- Network settings panel routines -- }
function saveNetworkState: OSErr;
function setNetworkState(state: Boolean): OSErr;
function restoreNetworkState: OSErr;

{ -- Security settings panel routines -- }
function saveSecurityState: OSErr;
function setSecurityState(state: Boolean; password: Str63): OSErr;
function restoreSecurityState: OSErr;

{ -- TollSaver settings panel routines -- }
function saveTollSaver: OSErr;
function setTollSaverState(state: Boolean): OSErr;
function setTollSaverTimes(beginHour: integer; beginMinute: integer; endHour: integer; endMinute: integer): OSErr;
function restoreTollSaver: OSErr;

{--------------------------------------------------------}
implementation

function Startup (Note: str255; SendTime: longint; AutoDeleteFax: Boolean; CallGroupFax: Boolean; CvPgId: integer; ArchiveFolderName: Str63): OSErr;
external;
function AddDestinations (SendToFaxPhone: Str31; SendToVoicePhone: Str31; SendToCoName: Str31; SendToFirstName: Str31; SendToLastName: Str31; SendToSalutation: Str15): OSErr;
external;
function ShutDown: OSErr;
external;
function DoSwitchPrinter (NewPrinter: Str31; var OldPrinter: Str31): OSErr;
external;
function doSwitchToFaxPrint (var oldPrinter: Str31 ): OSErr;
external;
function doRestorePrinter: OSErr;
external;
function doGetSoftwareState(var flag: Boolean): OSErr;
external;
function doScanSpoolFolder: OSErr;
external;
function isFaxSTFInstalled(var stfInstalled: integer): OSErr;
external;
function getSTFDriverStatus (var status: integer): OSErr;	
external;
function saveCurSettingsFile: OSErr;
external;
function switchSettingsFiles(newSettingsFileName: Str255): OSErr
external;
function restoreSettingsFile: OSErr;
external;
function saveCallBlockingState: OSErr;
external;
function setCallBlockingState(state: Boolean, number: Str63): OSErr;	
external;
function restoreCallBlockingState: OSErr;
external;
function saveConnectionSettings: OSErr;
external;
function setConnectionSettings(portName: Str63): OSErr;
external;
function restoreConnectionSettings: OSErr;
external;
function saveCoverPage: OSErr;						
external;
function setCoverPage(name: Str63; company: Str63; faxPhone: Str63; voicePhone:Str63): OSErr;
external;
function restoreCoverPage: OSErr;					
external;
function saveDialingSettings: OSErr;
external;
function setDialingSettings(phone: integer; detect: integer; carrier: integer; commaPause: integer; prefix: Str63; suffix: Str63; macro: Str63);
external;
function restoreDialingSettings: OSErr;
external;
function saveFaxForwardState: OSErr;
external;
function setFaxForwardState(state: Boolean; number: Str63): OSErr;	{ -- pass empty string for number to only toggle the state -- }
external;
function restoreFaxForwardState: OSErr;
external;
function saveFaxInState: OSErr;
external;
function setFaxInState(processType: integer; day: integer; hour: integer, minute: integer): OSErr;
external;
function restoreFaxInState: OSErr;
external;
function saveFaxMenuSettings: OSErr;
external;
function setFaxMenu(shiftKey: Boolean; commandKey: Boolean; optionKey: Boolean): OSErr;
external;
function restoreFaxMenuSettings: OSErr;
external;
function saveFaxModemSettings: OSErr;
external;
function setFaxModemSettings(speakerOn: integer; volume: integer; answerOn: integer; sendSpeed: integer; recvSpeed: integer);
external;
function restoreFaxModemSettings: OSErr;
external;
function saveFaxQueueSettings: OSErr;
external;
function setFaxQueueSettings(sampleRate: integer; sampleSize: integer; callGrouping: integer): OSErr;
external;
function restoreFaxQueueSettings: OSErr;
external;
function saveFaxSoftwareSettings: OSErr;
external;
function setFaxSoftwareSettings(callRetries: integer; retryInterval: integer; PageHeader: Boolean; confirmTrans: Boolean; notifyRecept: Boolean; faxStatus: Boolean; stationMessage: Str27);
external;
function pageHeaderOn: OSErr;
external;
function pageHeaderOff: OSErr;
external;
function faxOn: OSErr;
external;
function faxOff: OSErr;
external;
function restoreFaxSoftwareSettings: OSErr;
external;
function saveModemInitSettings: OSErr;
external;
function setModemInitSettings(initString: Str255): OSErr;
external;
function restoreModemInitSettings: OSErr;
external;
function savePageHeader: OSErr;
external;
function setPageHeaderOpts(icons: Boolean; date: Boolean; pages: Boolean; time: Boolean): OSErr;
external;
function setPageHeaderStandard(voice: Boolean; orginization: Boolean): OSErr;
external;
function setPageHeaderCustom(custHeader: Str63): OSErr;
external;
function restorePageHeader: OSErr;
external;
function savePlacesState: OSErr;
external;
function setPlacesState(index: integer): OSErr;		
external;
function restorePlacesState: OSErr;
external;
function saveNetworkState: OSErr;
external;
function setNetworkState(state: Boolean): OSErr;
external;
function restoreNetworkState: OSErr;
external;
function saveSecurityState: OSErr;
external;
function setSecurityState(state: Boolean; password: Str63): OSErr;
external;
function restoreSecurityState: OSErr;
external;
function saveTollSaver: OSErr;
external;
function setTollSaverState(state: Boolean): OSErr;
external;
function setTollSaverTimes(beginHour: integer; beginMinute: integer; endHour: integer; endMinute: integer): OSErr;
external;
function restoreTollSaver: OSErr;
external;

{--------------------------------------------------------}
end.